function Tekst_PDE(Model,nx,ny)
%Tekst_PDE(Model,nx,ny)
%  Geeft de model gegevens en de waarde van de discretsiatieparameters 
%  weer op het scherm

global MyGRIDSIZE MyMODEL
MyGRIDSIZE = [nx,ny];
MyMODEL=Model;

[X0,Y0]=feval(Model,'gebied');

hx=X0/(nx+1); hy=Y0/(ny+1);
[x,y]=ndgrid([0:hx:X0],[0:hy:Y0]);


[u,v]=feval(Model,x,y,'Advectie');
c=feval(Model,x,y,'Absorbtie');
f=feval(Model,x,y,'bronterm');

strPDE='    -d_x a d_x phi - d_y b d_y phi';
str='Diffusie vergelijking:';

if (norm(u,1)+norm(v,1)>0);
  str='Advectie-diffusie vergelijking:';
  strPDE=sprintf('%s%s',strPDE,' + d_x(u phi)+d_y(v phi)');
end
if (norm(c,1)>0)
  str=sprintf('%s%s',str,' met absorptie');
  strPDE=sprintf('%s%s',strPDE,'+c phi');
end
strbron='=0';
if (norm(f,1)>0)
  str=sprintf('%s%s',str,' en bronterm');
  strbron='=f';
end
strPDE=sprintf('%s%s',strPDE,strbron);
fprintf('\n%s\n%s',str,strPDE);


fprintf('\n    op D=[0,%d]x[0,%d]',X0,Y0)
fprintf('\nMet randvoorwaarden:')
fprintf('\n    -mu (a d_x phi, b d_y phi).n +(1-mu) phi = psi');
fprintf('\nDe coeffici\"enten, bronterm en randvoorwaarden\nzijn gefineerd in "%s.m".\n',Model);

pomp=feval(Model,'pomp');
if ~isempty(pomp)
  l=size(pomp,1);
  str=''; if (l>1) str='en'; end
  fprintf('\nPomp%s in ',str)
  for k=1:l
    fprintf('\n     (%g,%g) a %g kub/dag',...
    pomp(k,1),pomp(k,2),pomp(k,3))
  end
end

rivier=feval(Model,'rivier');
if ~isempty(rivier)
  l=size(rivier,1);
  str=''; if (l>1) str='en'; end
  fprintf('\nRivier%s in ',str)
  for k=1:l
   fprintf('\n rivier(%d):  {(x,y)|%g*x+%g*y=%g},  %g kub/dag m',...
   k,rivier(k,1),rivier(k,2),rivier(k,3),rivier(k,4))
 end
end


fprintf('\n\nDiscretiseer op een %dx%d rooster',nx,ny),
fprintf('\nmet centrale eindige differenties.\n\n')

return
