function [b,x]=PreProcess(A,b,x,D,ptype)
% [b,x0]=PreProcess(A,b,x0,D,ptype)
%
%   Form the L and U factors for the preconditioner
%   These factors are handed (as global variables) to the function
%   subroutines  Msolve (for implicit preconditioning)
%   PMV (for explicit preconditioning) and Postproces (to
%   unprecondition the solution in case of explicit right preconditioning)
%
%   Precondition x0 and b in case of explicit left or right preconditioning
%
%   Possible values for ptype
%     'DILU'               for implicite preconditioning
%     'Diagonal'           for implicite preconditioning   
%     'RightDILU'          for right explicit preconditioning
%     'LeftDILU'           .....
%     'LeftDiagonal'
%     'RightDiagonal'
%     'SymDiagonal'


% the following gobal variables are handed to the 'precontioned"
% function subroutines Msolve, PMV, PostProces. They are to be defined
% here.
%
% MyPTYPE = ptype
global MyPTYPE 
% MyMATRIX = A
% MyDIAGONAL = D
% MyLOWERTRIANGULAR = (LA+D)/D = (LA/D)+I met LA strikt beneden driehoek A
% MyUPPRTRIANGULAR = D+UA met UA strikt boven driehoek A 
global MyMATRIX MyDIAGONAL MyLOWERTRIANGULAR MyUPPERTRIANGULAR 


% MyGRIDSIZE = [nx ny] size of the grid, is defined in "Tekst_PDE.m"
global MyGRIDSIZE
% MyPRESTING is a string that is used in the output routine "ShowMethod"
% To be defined here.
global MyPRESTRING


MyMATRIX=A;

if nargin > 3, MyDIAGONAL=D; end

if nargin < 5, 
  MyPTYPE='NoPreconditioning'; 
  MyPRESTRING='no.';
  return
end

MyPTYPE=ptype;

n=size(A,1);


  switch MyPTYPE
  case  {'DILU','RightDILU','LeftDILU'}
  
    %%  M=((LA+D)/D)*(D+UA)=(LA/D+I)*(D+UA)
    %%  L=LA/D+I; U=D+UA;
    nx= MyGRIDSIZE(1,1); d=[-nx,-1,0,1,nx];
    B=spdiags(A,d);
    i=[4,5]; 
    MyUPPERTRIANGULAR=spdiags(B(:,i),d(i),n,n)+D;

%%%%%%%%  i=[1,2]; MyLOWERTRIANGULAR=?????;
    
      switch MyPTYPE
      case  'RightDILU'
         PREx=(norm(x)>0);
	 if PREx

%%%%%%%%% x=????;

	 end
	 MyPRESTRING='explicit right with D-ILU.';
      case  'LeftDILU'

%%%%%%%%% b=?????;

	 MyPRESTRING='explicit left with D-ILU.';
      otherwise
 	 MyPRESTRING='implicit with D-ILU.';
     end
    
  case 'Diagonal'

      MyDIAGONAL=D;
      MyPRESTRING='implicit diagonal.';

  case 'LeftDiagonal'

%%%%%%%%% ????

  case 'RightDiagonal'

%%%%%%%%% ????

  case 'SymDiagonal'

%%%%%%%%% ????

  otherwise
     MyPRESTRING='no.';
  end

return
